package com.horizon.wf.entity.db;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.horizon.wf.global.StaticVarExtend;

/*
create table TW_HORIZON_TASK_LOG
(
  ID         VARCHAR(32)  CHARACTER SET utf8 COLLATE utf8_bin not null,
  WORKID     VARCHAR(32)  CHARACTER SET utf8 COLLATE utf8_bin,
  NODEID     VARCHAR(32)  CHARACTER SET utf8 COLLATE utf8_bin,
  NODENAME   VARCHAR(256) CHARACTER SET utf8 COLLATE utf8_bin,
  REMSGDATE  VARCHAR(20) CHARACTER SET utf8 COLLATE utf8_bin,
  REMSGNODE  VARCHAR(256) CHARACTER SET utf8 COLLATE utf8_bin,
  
  SENDER    VARCHAR(50) CHARACTER SET utf8 COLLATE utf8_bin,
  RECEIVER  longtext CHARACTER SET utf8 COLLATE utf8_bin,
  MEMO      longtext CHARACTER SET utf8 COLLATE utf8_bin,
  TITLE     VARCHAR(200) CHARACTER SET utf8 COLLATE utf8_bin,
  Trackid	 VARCHAR(32)  CHARACTER SET utf8 COLLATE utf8_bin,
  
  F1		 VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_bin,
  F2		 VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_bin,
  F3		 VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_bin,
  F4		 VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_bin,
  constraint PK_TW_HORIZON_TASK_LOG primary key (ID)
)ENGINE=InnoDB DEFAULT CHARSET=utf8;
 */
/**
 * 催办信息记录
 * @author liyong
 *  2012-11-10
 */
public class DBTaskLog extends BaseEntity{
	
	private static final long serialVersionUID = 1L;
	private String workid;
	private String nodeid;
	private String nodename;
	private String remsgdate;
	private String remsgnode;	
	
	private String sender;
	private String receiver; 
	private String memo;
	private String title;
	private String trackid;
	
	private static String tableName = StaticVarExtend.Table_Task_Log;
	
//	protected void exeJSON(JSONObject json){
//		JSONArray jsonArr = json.getJSONArray("DBTaskLog");
//		if(jsonArr == null){
//			jsonArr = new JSONArray();
//			json.put("DBTaskLog", jsonArr);
//		}
//		else{
//			JSONObject tmpObj;
//			for(int i=0,n=jsonArr.size();i<n;i++){
//				tmpObj = jsonArr.getJSONObject(i);
//				if(id.equals(tmpObj.getString("id"))){
//					jsonArr.remove(i);
//					break;
//				}
//			}
//		}
//		Object thisObj = JSON.toJSON(this);
//		jsonArr.add(thisObj);
//		
//		
//	}
	
	protected void getSQL(Map<String,List<Object>> saveMap) {
		StringBuilder sb = new StringBuilder(500) ;
		List<Object> dlst = new ArrayList<Object>();
		
		saveMap.put("DELETE FROM "+tableName+" WHERE ID='"+getId()+"'", null);
		
		sb.append("INSERT INTO  " +tableName +" (ID,")
		  .append("WORKID,NODEID,NODENAME,REMSGDATE,REMSGNODE,")
		  .append("SENDER,RECEIVER,MEMO,TITLE,TRACKID) ")
		  .append(" VALUES('").append(getId()).append("',?,?,?,?,?,?,?,?,?,?)");
					
		dlst.add(workid);
		dlst.add(nodeid);
		dlst.add(nodename);
		dlst.add(remsgdate);
		dlst.add(remsgnode);
		
		dlst.add(sender);
		dlst.add(receiver);
		dlst.add(memo);
		dlst.add(title);
		dlst.add(trackid);
		saveMap.put(sb.toString(), dlst);
	}
	public String getWorkid() {
		return workid;
	}
	public void setWorkid(String workid) {
		this.workid = workid;
	}
	public String getNodeid() {
		return nodeid;
	}
	public void setNodeid(String nodeid) {
		this.nodeid = nodeid;
	}
	public String getNodename() {
		return nodename;
	}
	public void setNodename(String nodename) {
		this.nodename = nodename;
	}
	public String getRemsgdate() {
		return remsgdate;
	}
	public void setRemsgdate(String remsgdate) {
		this.remsgdate = remsgdate;
	}
	public String getRemsgnode() {
		return remsgnode;
	}
	public void setRemsgnode(String remsgnode) {
		this.remsgnode = remsgnode;
	}
	public String getSender() {
		return sender;
	}
	public void setSender(String sender) {
		this.sender = sender;
	}
	public String getReceiver() {
		return receiver;
	}
	public void setReceiver(String receiver) {
		this.receiver = receiver;
	}
	public String getMemo() {
		return memo;
	}
	public void setMemo(String memo) {
		this.memo = memo;
	}
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	public String getTrackid() {
		return trackid;
	}
	public void setTrackid(String trackid) {
		this.trackid = trackid;
	}
}
